//servo
#include <Servo.h>
Servo myservo;
int pos = 0;
float z_init = 0;

//mpu
#include <Wire.h>
#include <LIS3MDL.h>
#include <math.h>
LIS3MDL mag; //create a mag object


//vibration motors
int C = 10; //Back
int B = 6; //Middle
int A = 11;  //front

int button = 7;

//Pressure Sensor
#define front A1
#define back A0

void setup() {
  //servo
  myservo.attach(9);

  //IMU
  Serial.begin(9600); //initialize serial monitor at 9600 baud rate
  Wire.begin(); //begin I2C transmission.


  //vibration motors
  // initialize digital pin LED_BUILTIN as an output.
  pinMode(A, OUTPUT);
  pinMode(B, OUTPUT);
  pinMode(C, OUTPUT);
  analogWrite(A, 0);
  analogWrite(B, 0);
  analogWrite(C, 0);


  //Pressure Sensor
  Serial.begin(9600);
  pinMode(back, INPUT);
  pinMode(front, INPUT);

}

void loop() {
  //Pressure Sensor
  float frontp = analogRead(back);
  float backp = analogRead(front);
//  Serial.print(backp);
//  Serial.print(',');
//  Serial.println(frontp);
//  delay(100);

  float z_avg = 1000;
  if (digitalRead(button) == HIGH) {
    //Serial.println("high");
    z_avg = calibrate(A);
  }
  //Vibration motor
  if (backp >800 && backp - frontp >= -100 ) {
    backwave(C, B, A);
  }
  else if (frontp > 900 && frontp - backp >= 100){
    backwave(A, B, C);
  }


  //IMU
  if (!mag.init()) { //if the magentometer is not initialized
    Serial.println("Failed to detect and initialize magnetometer!");
    while (1); //continuously print failure to the serial monitor
  }
  mag.enableDefault(); //set up the magnetometer with default
  mag.read(); //read the magnetometer

  float z_fin = mag.m.z;
  //Serial.println(z_fin);

  //when the IMU reads a a value over 18 degrees to the left
  if (z_fin > z_avg + 50) {
    myservo.write(35);
    delay(500);
    //return to original value after notifying the user
    myservo.write(90);
    delay(100);
  }
  //when the IMU reads a avalue over 18 degrees to the right
  if (z_fin < z_avg - 2500) {
    myservo.write(140);
    delay(500);
    //return to original value after notifying the user}
    myservo.write(90);
    delay(100);

    //Establishing a new initial value given tha value we used in this iteration
    //        z_init = z_fin;
  }
  // if the runner is adhering to the guidelines, do nothing
  else {
  }
}

//
void backwave(int A, int B, int C) {
  analogWrite(C, 255);
  delay(500);
  analogWrite(C, 0);
  analogWrite(B, 255);
  delay(500);
  analogWrite(B, 0);
  analogWrite(A, 255);
  delay(500);
  analogWrite(A, 0);
  delay(750);
}

float calibrate(int C) {
  Serial.println("calibrating");
  analogWrite(C, 255);
  delay(1000);
  analogWrite(C, 0);

  float z_avg = 0;
  int i = 0;
  float z_sum = 0;
  unsigned long init_time = millis();
  while (millis() - init_time < 10000) {
    if (!mag.init()) { //if the magentometer is not initialized
      Serial.println("Failed to detect and initialize magnetometer!");
      while (1); //continuously print failure to the serial monitor
    }
    mag.enableDefault(); //set up the magnetometer with default
    mag.read(); //read the magnetometer

    float z_fin = mag.m.z;
    z_sum = z_sum + z_fin;
    i = i + 1;
    //Serial.println(z_sum);
  }
  z_avg = z_sum / i;
  Serial.println("done calibrating");

  analogWrite(C, 255);
  delay(1000);
  analogWrite(C, 0);
  delay(500);
  analogWrite(C, 255);
  delay(1000);
  analogWrite(C, 0);
  delay(500);
  analogWrite(C, 255);
  delay(1000);
  analogWrite(C, 0);
  return z_avg;
}
